## lbfgspp 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(lbfgspp VERSION 0.4.0 LANGUAGES CXX)

# + ----------------- +
# | BUILDING SETTINGS |
# + ----------------- +

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_BUILD_TYPE)

# + ----------------- +
# | COMPILATION FLAGS |
# + ----------------- +

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wall WALL_SUPPORTED)
if(${WALL_SUPPORTED})
  add_compile_options(-Wall)
endif()

# + --------------- +
# | LBFGSpp LIBRARY |
# + --------------- +

add_library(lbfgspp INTERFACE)

# + -------- +
# | INCLUDES |
# + -------- +

target_include_directories(lbfgspp INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
)

# + ----------------------- +
# | FIND EXTERNAL LIBRARIES |
# + ----------------------- +

find_package(Eigen3 3.0 REQUIRED)
target_link_libraries(lbfgspp INTERFACE Eigen3::Eigen)
message("-- Eigen3 version: " ${EIGEN3_VERSION_STRING})

# + ------------ +
# | INSTALLATION |
# + ------------ +

# Copy headers folder
install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
  DESTINATION include
)
# Create an export set
install(TARGETS lbfgspp EXPORT lbfgsppTargets)

include(CMakePackageConfigHelpers)
# Version file
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/lbfgspp-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
)
# Config file
configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/lbfgspp-config.cmake
  INSTALL_DESTINATION lib/cmake/lbfgspp
)
# Targets files
export(
  EXPORT lbfgsppTargets
  FILE ${CMAKE_CURRENT_BINARY_DIR}/lbfgspp-targets.cmake
)
install(
  EXPORT lbfgsppTargets
  FILE lbfgspp-targets.cmake
  DESTINATION lib/cmake/lbfgspp
)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/lbfgspp-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/lbfgspp-config-version.cmake
  DESTINATION lib/cmake/lbfgspp
)

add_subdirectory(examples)

=== examples/CMakeLists.txt ===
foreach (source example-quadratic.cpp example-rosenbrock-box.cpp example-rosenbrock-bracketing.cpp example-rosenbrock-comparison.cpp example-rosenbrock.cpp)
    get_filename_component(example ${source} NAME_WLE)
    add_executable(${example} ${source})
    set_property(TARGET ${example} PROPERTY CXX_STANDARD 17)
    target_link_libraries(${example} PRIVATE lbfgspp Eigen3::Eigen)
endforeach ()

## lbfgspp 0.1.0

=== debian/changelog ===
lbfgspp (0.1.0-1) unstable; urgency=medium

  * d/watch: Seek versioned releases instead of git head
    now that upstream tagged a release
  * New upstream version 0.1.0
  * d/examples: Install examples from examples dir

 -- Nilesh Patra <nilesh@debian.org>  Sat, 06 Nov 2021 19:41:14 +0530

lbfgspp (0.0+git20210613.d50344d-1) unstable; urgency=medium

  * Initial release (Closes: #991072)

 -- Nilesh Patra <nilesh@debian.org>  Tue, 13 Jul 2021 20:55:33 +0530

=== debian/control ===
Source: lbfgspp
Section: libdevel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nilesh Patra <nilesh@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/lbfgspp
Vcs-Git: https://salsa.debian.org/science-team/lbfgspp.git
Homepage: https://github.com/yixuan/LBFGSpp
Rules-Requires-Root: no

Package: liblbfgspp-dev
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: C++ library that implements the Limited-memory BFGS algorithm
 LBFGS++ is a header-only C++ library that implements the Limited-memory BFGS
 algorithm (L-BFGS) for unconstrained minimization problems, and a modified
 version of the L-BFGS-B algorithm for box-constrained ones.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/yixuan/LBFGSpp/tags (?:.*?/)?v?@ANY_VERSION@\.tar\.gz

## lbfgspp 0.4.0

=== debian/changelog ===
lbfgspp (0.4.0-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 0.4.0
  * Move d/watch to version 5
  * Add d/gbp.conf
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Drop Redundant "Rules-Requires-Root: no"
  * Add cmake and libeigen3-dev to B-D
  * Drop myself from uploaders

 -- Nilesh Patra <nilesh@debian.org>  Sun, 02 Nov 2025 22:24:36 +0530

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,11 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Nilesh Patra <nilesh@debian.org>
-Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), cmake, libeigen3-dev
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/lbfgspp
 Vcs-Git: https://salsa.debian.org/science-team/lbfgspp.git
 Homepage: https://github.com/yixuan/LBFGSpp
-Rules-Requires-Root: no
 
 Package: liblbfgspp-dev
 Architecture: all

=== debian/watch ===
Version: 5

Template: Github
Owner: yixuan
Project: LBFGSpp
